/*--------------------------------------------------------------------------
Programao para teste da placa PG04
Verso 2004   1-Junho-2004
Joo Lus Sobral - Departamento de Informtica - Universidade do Minho
---------------------------------------------------------------------------*/

#include<stdio.h>
#include<stdlib.h>
#include <fcntl.h>
#include<io.h>
#include <string.h>
#include <math.h>

unsigned char *Vector;
double freq=10000.0;           // nmero de amostragem por segundo
double duracao=3;			   // tempo de amostragem (em segundos)

/*-------------------------- Gerar um som por defeito ---------------------*/

double amo=8;

void limpa_vector() {
    for (long int n=0; n < freq * duracao; n++)  {
        double factor = 128 + 128 * sin ( ((double) n)/amo );
        Vector[n]= (int) factor;
    }
}

/*------------------------------------------------------------------------*/

void aloca_mem(long size) {
    Vector = (unsigned char *) malloc(size);
}

/*------------------------------------------------------------------------*/

struct wave {
   char riff[4];     char lixo[4];
   char wav[4];       char fmt[4];
   short int format;  short int lixo1;
   short int canais;  short int lixo2;
   int freq;		  int bps;
   short int bloco;
   short int bits;
   char data[4];
   int tam;
};

struct wave2 {
 	char riff[4];       char lixo[4];
   char wave[4];        char fmt[4];
   short int format;    short int lixo1;
   short int canais;    short int lixo2;
   int freq;            int bps;
   short int bloco;
   short int bits;      short int dt;           // s fact
   char fact[4];     // s fact
   int ftam;    // s fact
   char lixo4[2];    // s fact
   char data[4];
   short int tam;
};

void printinfo(struct wave *wv) {
	printf("riff=%.4s, wave=%.4s, fmt=%.4s\n",wv->riff,wv->wav,wv->fmt);
   printf("format=%x, %d canais, freq=%ld\n",wv->format,wv->canais,wv->freq);
   printf("bps=%ld, bloco=%d, bits=%d\n",wv->bps,wv->bloco,wv->bits);
   if (wv->format == 0x12) {
   	struct wave2 *wv2 = (struct wave2 *) wv;
   	printf("fact=%.4s data=%.4s, tam=%ld\n",wv2->fact,wv2->data,wv2->tam);
   } else
   	if (wv->format == 0x10)
   		printf("data=%.4s, tam=%ld\n",wv->data,wv->tam);
    else printf("Formato WAV desconhecido = %x\n",wv->format);
   printf("lixo=%.4s, lixo1=%d, lixo2=%d\n", wv->lixo, wv->lixo1, wv->lixo2);
}

void ler_wave() {
	int  handle; 	long size;
   char * FileName = "SomE.wav";
	double  DataSize;                  //  Nmero de bytes do WAV

	if  (( handle = open( FileName, O_RDONLY | O_BINARY )) == - 1 )
      printf( "\"%s\" nao foi encontrado\n", FileName );
   else {
      size = lseek( handle, 0L, SEEK_END );    // determinar tam. do ficheiro
      aloca_mem(size);

      lseek( handle, 0L, SEEK_SET );

      read( handle, Vector, size );  			//  ler ficheiro
      struct wave *wv = (struct wave *) &Vector[ 0 ];

      printinfo(wv);

	if (( strncmp( wv->riff, "RIFF", 4 ) != 0 ) ||
      	 ( strncmp( wv->wav, "WAVE", 4 ) != 0 ) ||
          ( strncmp( wv->fmt , "fmt ", 4 ) != 0 ))
                   printf( "\"%s\" nao e um fiheiro .WAV valido\n", FileName );
      else {
      	freq = wv->freq;
         printf("Freq = %.2f\n",freq);

			if (wv->format == 0x12) {
		   	 struct wave2 *wv2 = (struct wave2 *) wv;
             DataSize = wv2->tam;
   		} else
   				if (wv->format == 0x10)  DataSize = wv->tam;
               else printf( "%x nao e um tipo .WAV valido\n",wv->format);

         printf("Data = %.0f\n",DataSize);
         duracao = DataSize/(double)freq;
         printf("duracao = %.2f\n",duracao);

       }
      close( handle );
   }

}

/*------------------------------------------------------------------------*/

void grava_wave() {
	int  handle;
   char * FileName = "SomS.wav";
	double  DataSize;                  //  Number of Bytes to Send

	if  (( handle = open( FileName, O_WRONLY | O_BINARY | O_CREAT)) == - 1 )
      printf( "\"%s\" could not be open\n", FileName );
   else {                      //  Go Ahead and Process the File

      struct wave *wv = (struct wave *) &Vector[ 0 ];
   	  strncpy(wv->riff,"RIFF    ", 8 );
      strncpy(wv->wav, "WAVE", 4 );
      strncpy(wv->fmt, "fmt ", 4 );
      strncpy(wv->data, "data", 4 );
      wv->format=0x10;
      wv->canais=1;
      wv->bits=8;
      wv->bloco=1;
      wv->lixo1=0;
      wv->lixo2=1;

      wv->freq = (int) freq;
      wv->tam = (int) (freq*duracao);
      wv->bps = wv->freq;

      printinfo(wv);

      write( handle, Vector, (int) (freq*duracao) + sizeof(struct wave) );  //  write in the File

         //  Go ahead and Process the File

      			freq = Vector[ 24 ] + ( Vector[ 25 ] * 256 );
               printf("Temp = %.0f\n",freq);

               double f1, f2,f3;
               f1 = Vector[ 40 ]; f2 =  Vector[ 41 ]; f3 = Vector[ 43 ];
               DataSize = f1+256L*f2+65536L*f3;
 
               printf("Data = %.0f\n",DataSize);
               duracao = DataSize/freq;

               printf("duracao = %.2f\n",duracao);

      }  /*  endif  */
      close( handle );
  }

/*------------------------------------------------------------------------*/


void filtra() {
	int dimFiltro;
   int acc;
   char buffer[15];
   printf("Tamanho do filtro?"); gets(buffer);  dimFiltro = atoi(buffer);
   for (long int n=100; n < freq * duracao - dimFiltro; n++)  {
   	acc = 0;
   	for (int i=0; i<dimFiltro; i++) acc += Vector[n+i];
      Vector[n] = acc/dimFiltro;
   }
}

 /*------------------------------------------------------------------------*/
/*       GERAL                                                            */
/*------------------------------------------------------------------------*/

void menu() {
    printf("\n\n");
    printf("6 - Ler de somE.wav\n");
    printf("7 - Gravar para somS.wav\n");
	printf("A - Aplicar filtro ruido\n");
    printf("0 - Sair.");
}
/*------------------------------------------------------------------------*/

char prompt() {
    char opcao;

    printf("\nPG04> ");
    opcao=toupper(getchar());
    if (opcao != '\n') while (getchar() != '\n');
    return (opcao);
}
/*------------------------------------------------------------------------*/

void main() {
    char opcao;

	printf("\n---------------------------------------------------\n");
    printf("Programa Tipo, ler e gravar um wave\n\n");
    printf("Arquitectura de Computadores II, UMinho, JLS Junho/2004\n");
    printf("---------------------------------------------------\n");

    printf("Frequencia de amostragem %.0f Hz, %.2f segundos\n",freq,duracao);

    aloca_mem((long)(freq*duracao));
    limpa_vector();

    menu();
    opcao=prompt();

    while(opcao!='0') {
      switch(opcao) {
        case '6' : ler_wave(); break;
        case '7' : grava_wave(); break;
        case 'A' : filtra(); break;
        default  : menu();
      }
      opcao=prompt();
    }
    free(Vector);
}
